/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package server;

import controller.Controller;
import domain.User;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Map;
import transfer.RequestObject;
import transfer.ResponseObject;
import util.Operation;

/**
 *
 * @author student1
 */
public class Server {
    ServerSocket serverSocket;
    Socket socket;

    public Server() {
    }
    
    public void start() throws IOException, Exception{
        serverSocket=new ServerSocket(9000);
        System.out.println("waiting...");
        socket=serverSocket.accept();
        System.out.println("client connected!!!");
        
        handleClient();
    }
    
    
    private void handleClient() throws IOException, ClassNotFoundException, Exception{
        
        while (true){
            RequestObject request=receiveRequest();
            ResponseObject response=null;
            switch(request.getOperation()){
                case Operation.OPERATION_LOGIN:
                    Map<String, String> data=(Map<String, String>)request.getData();
                    String username=(String)data.get("username");
                    String password=(String)data.get("password");
                    response=new ResponseObject();
                    try{
                        User user=Controller.getInstance().logIn(username, password);
                        response.setData(user);
                    }catch(Exception e){
                        e.printStackTrace();
                        response.setException(e);
                    }
                    break;
                    
            }
            sendResponse(response);
            
        }
    }
    
    private RequestObject receiveRequest() throws IOException, ClassNotFoundException{
        ObjectInputStream in=new ObjectInputStream(socket.getInputStream());
        return (RequestObject)in.readObject();
    }
    
    private void sendResponse(ResponseObject response) throws IOException{
        ObjectOutputStream out=new ObjectOutputStream(socket.getOutputStream());
        out.writeObject(response);
        out.flush();
    }
}
